#line 1 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/TFT/TFT eigene Programme/libelle_eve/libelle_eve_Code/mikroC PRO for PIC32/libelle_eve_driver.c"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/tft/tft eigene programme/libelle_eve/libelle_eve_code/mikroc pro for pic32/libelle_eve_objects.h"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/tft/tft eigene programme/libelle_eve/libelle_eve_code/mikroc pro for pic32/ft800_types.h"
#line 21 "c:/users/alexander wolf/documents/projekte/programmierung/pic/tft/tft eigene programme/libelle_eve/libelle_eve_code/mikroc pro for pic32/ft800_types.h"
typedef unsigned char uint8_ft8;
typedef signed char int8_ft8;
typedef unsigned int uint16_ft8;
typedef int int16_ft8;
typedef unsigned long uint32_ft8;
typedef long int32_ft8;
typedef unsigned long long uint64_ft8;
typedef long long int64_ft8;

typedef enum {cmdREAD, cmdWRITE} TCmd;

typedef enum {opNONE, opREAD, opWRITE} TOpr;

typedef enum {umNONE, umDL=1<<0, umCP=1<<1, umGRAM=1<<2} TUpdateMode;

typedef uint8_ft8 TFT800Alpha;
typedef uint8_ft8 TFT800Handle;

typedef struct
{
 int16_ft8 X;
 int16_ft8 Y;
} TFT800Point;

typedef struct
{
 int16_ft8 Left;
 int16_ft8 Top;
 uint16_ft8 Width;
 uint16_ft8 Height;
} TFT800Rect;

typedef union
{
 struct
 {
 uint8_ft8 B;
 uint8_ft8 G;
 uint8_ft8 R;
 };
 uint32_ft8 RGB;
} TFT800Color;

typedef struct
{
 TFT800Color Color;
 TFT800Alpha Alpha;
 uint8_ft8 Width;
} TFT800Pen;

typedef struct
{
 TFT800Color ColorBg;
 TFT800Color Color;


 TFT800Color ColorTo;
 uint8_ft8 Gradient;
 TFT800Alpha Alpha;
 uint8_ft8 Style;
} TFT800Brush;




typedef struct
{

 uint8_ft8 FontWidth[ 256 ];
 uint32_ft8 FontBitmapFormat;
 uint32_ft8 FontLineStride;
 uint32_ft8 FontWidthInPixels;
 uint32_ft8 FontHeightInPixels;
 uint32_ft8 PointerToFontGraphicsData;
} TFT800FontGraphics;

typedef struct
{
 TFT800FontGraphics GrData;
 uint16_ft8 FirstChar;
 uint16_ft8 LastChar;
} TFT800CharSetDsc;

typedef struct
{
 uint32_ft8 Name;
 uint32_ft8 Source;
 TFT800Color Color;
 TFT800Alpha Alpha;
 TFT800Handle Handle;
 TFT800CharSetDsc CharSetDsc;
} TFT800Font;

typedef struct
{
 uint8_ft8 Format;
 uint16_ft8 LineStride;
 uint16_ft8 Height;
} TFT800BmpLayout;

typedef struct
{
 uint8_ft8 FwFlags;
 uint16_ft8 Width;
 uint16_ft8 Height;
} TFT800BmpSize;

typedef struct
{
 uint32_ft8 Source;
 TFT800BmpLayout Layout;
 TFT800BmpSize Size;
} TFT800BmpConfig;

typedef struct
{
 TFT800BmpConfig Configs[16];
 uint8_ft8 Current;
} TFT800BmpHandle;

typedef struct
{
 TFT800BmpConfig Config;
 TFT800Color BlendColor;
 TFT800Alpha Alpha;
 TFT800Handle Handle;
} TFT800Bitmap;

typedef struct
{
 uint16_ft8 Hour;
 uint16_ft8 Min;
 uint16_ft8 Sec;
 uint16_ft8 mSec;
} TFT800Time;

typedef struct
{
 uint32_ft8 DrawingOptions;
 uint16_ft8 Val;
 uint16_ft8 Size;
 uint16_ft8 Range;
 uint16_ft8 Minor;
 uint16_ft8 Major;
 TFT800Time Time;
 uint8_ft8 Style;
} TFT800CoProcGraphics;

typedef struct
{
 TFT800Pen Pen;
 TFT800Brush Brush;
 TFT800Font Font;
 TFT800Bitmap Bitmap;

 TFT800Rect ClipRect;
 TFT800Point Cursor;

 uint8_ft8 Stencil;
 uint8_ft8 Tag;

 TFT800CoProcGraphics CPGraphics;
} TFT800Canvas;

typedef struct
{
 TOpr Opr;
 uint32_ft8 RWPtr;
} TFT800IO;


typedef struct
{

 uint32_ft8 Frequency;
 uint32_ft8 OutRenderMode;
 uint32_ft8 RenderReadScanLine;
 uint32_ft8 RenderWriteTrigger;

 uint32_ft8 hCycle;
 uint32_ft8 hOffset;
 uint32_ft8 hSize;
 uint32_ft8 hSync0;
 uint32_ft8 hSync1;

 uint32_ft8 vCycle;
 uint32_ft8 vOffset;
 uint32_ft8 vSize;
 uint32_ft8 vSync0;
 uint32_ft8 vSync1;

 uint32_ft8 Rotate180;
 uint32_ft8 OutBits;
 uint32_ft8 OutDither;
 uint32_ft8 OutSwizzle;
 uint32_ft8 OutCSpread;
 uint32_ft8 PClockPolarity;
 uint32_ft8 PClock;
} TFT800Display;

typedef struct
{
 uint32_ft8 TouchMode;
 uint32_ft8 TouchADCMode;
 uint32_ft8 TouchCharge;
 uint32_ft8 TouchSettle;
 uint32_ft8 TouchOversample;
 uint32_ft8 TouchRZThreshold;
} TFT800Touch;

typedef struct
{
 uint32_ft8 TransformA;
 uint32_ft8 TransformB;
 uint32_ft8 TransformC;
 uint32_ft8 TransformD;
 uint32_ft8 TransformE;
 uint32_ft8 TransformF;
} TFT800TouchTransform;

typedef struct
{
 uint8_ft8 Enable;
 uint8_ft8 Mask;
 uint8_ft8 Flags;
} TFT800Interrupt;

typedef struct
{
 uint8_ft8 Effect;
 uint8_ft8 Pitch;
 uint8_ft8 Volume;
 uint8_ft8 Play;
} TFT800Sound;

typedef struct
{
 uint32_ft8 StartAddress;
 uint32_ft8 Length;
 uint16_ft8 Frequency;
 uint8_ft8 Format;
 uint8_ft8 Loop;
 uint8_ft8 Volume;
 uint8_ft8 Play;
} TFT800Audio;

typedef struct
{

 uint16_ft8 Freq;
 uint8_ft8 Duty;
} TFT800PWM;

typedef struct
{
 uint8_ft8 GPIODIR;
 uint8_ft8 GPIO;
} TFT800GPIO;

typedef struct
{
 TFT800PWM *pPWMCfg;
 TFT800GPIO *pGPIOCfg;
 TFT800Audio *pAudioCfg;
 TFT800Sound *pSoundCfg;
 TFT800Touch *pTouchCfg;
 TFT800Display *pDisplayCfg;
 TFT800Interrupt *pInterruptCfg;
 TFT800TouchTransform *pTTransformCfg;
} TFT800Config;



typedef struct
{
 struct
 {




 TFT800Color Color;
 TFT800Alpha Alpha;

 uint8_ft8 Tag;

 TFT800Color ClearColor;
 TFT800Alpha ClearAlpha;
 uint8_ft8 ClearStencil;
 uint8_ft8 ClearTag;

 uint16_ft8 LineWidth;
 uint16_ft8 PointSize;

 uint16_ft8 ScissorLeft;
 uint16_ft8 ScissorTop;
 uint16_ft8 ScissorWidth;
 uint16_ft8 ScissorHeight;

 uint8_ft8 BmpHandle;
 uint8_ft8 Cell;

 struct
 {
 Color : 1;
 Alpha : 1;
 Tag : 1;
 ClearColor : 1;
 ClearAlpha : 1;
 ClearStencil : 1;
 ClearTag : 1;
 LineWidth : 1;
 PointSize : 1;
 ScissorPos : 1;
 ScissorSize : 1;
 BmpHandle : 1;
 Cell : 1;

 Unused : 32-13;

 } UpdateFlags;


 } Context;

 TFT800BmpConfig BmpHandleCfg[16];

 int8_ft8 CurrGrPrim;
} TFT800Graphics;

typedef struct
{
 TFT800IO IO;

 TFT800Sound Sound;

 TFT800Audio Audio;

 TFT800Graphics Graphics;

 struct
 { uint16_ft8 Width;
 uint16_ft8 Height;
 } Display;

 uint8_ft8 UpdateMode;

} TFT800Controller;
#line 6 "c:/users/alexander wolf/documents/projekte/programmierung/pic/tft/tft eigene programme/libelle_eve/libelle_eve_code/mikroc pro for pic32/libelle_eve_objects.h"
typedef enum {taNone, taLeft, taCenter, taRight, taCenterX, taCenterY, taRightX} TTextAlign;

typedef struct Screen TScreen;

typedef unsigned long TPointer;

typedef struct tagObjInfo {
 void *Obj;
 char Type;
 char Order;
 char Flags;

 char HitTag;
 int HitX;
 int HitY;
} TObjInfo;

typedef struct tagTouchStat {
 char Pressed;

 char Tag;
 int X;
 int Y;

 TObjInfo ActObjInfo;
} TTouchStat;

typedef void (*TDrawHandler)(TPointer aObj);

typedef void (*TEvtAction)();

typedef struct tagEvtSound {
 char SndAct;
 char Effect;
 char Pitch;
 char Volume;
} TEvtSound;

typedef const struct tagCEvent {
 TEvtAction Action;
 TEvtSound Sound;
} TCEvent;

typedef struct tagEvent {
 TEvtAction Action;
 TEvtSound Sound;
} TEvent;

typedef const struct tagCRect {
 int Left;
 int Top;
 int Width;
 int Height;
} TCRect;

typedef struct tagRect {
 int Left;
 int Top;
 int Width;
 int Height;
} TRect;

typedef struct tagLabel {
 TScreen *OwnerScreen;
 char Order;
 char Visible;
 char Opacity;
 char Tag;
 int Left;
 int Top;
 int Width;
 int Height;
 char *Caption;
 const code char *FontName;
 unsigned int Font_Color;
 char FontHandle;
 long Source;
 char Active;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnClick;
 TEvent *OnPress;
} TLabel;

typedef struct tagCircle {
 TScreen *OwnerScreen;
 char Order;
 char Visible;
 char Opacity;
 char Tag;
 int Left;
 int Top;
 int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 unsigned int Color;
 unsigned int Press_Color;
 char Active;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnClick;
 TEvent *OnPress;
} TCircle;

typedef struct tagEveSlider {
 TScreen *OwnerScreen;
 char Order;
 char Visible;
 char Opacity;
 char Tag;
 int Left;
 int Top;
 int Width;
 int Height;
 unsigned int Background_Color;
 unsigned int Thumb_Color;
 unsigned int Color;
 unsigned int Press_Color;
 unsigned int Value;
 unsigned int Range;
 char Flat;
 char Active;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnClick;
 TEvent *OnPress;
} TEveSlider;

typedef struct tagEveText {
 TScreen *OwnerScreen;
 char Order;
 char Visible;
 char Opacity;
 char Tag;
 int Left;
 int Top;
 int Width;
 int Height;
 char *Caption;
 TTextAlign TextAlign;
 const code char *FontName;
 unsigned int Font_Color;
 char FontHandle;
 long Source;
 char Active;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnClick;
 TEvent *OnPress;
} TEveText;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned short LabelsCount;
 TLabel *const code *Labels;
 unsigned short CirclesCount;
 TCircle *const code *Circles;
 unsigned short EveSlidersCount;
 TEveSlider *const code *EveSliders;
 unsigned short EveTextsCount;
 TEveText *const code *EveTexts;
 unsigned long DynResStart;
 unsigned short Active;
 unsigned short SniffObjectEvents;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnTagChange;
 TEvent *OnPress;
};




extern const VTFT_OT_LABEL;
extern const VTFT_OT_CIRCLE;
extern const VTFT_OT_EVESLIDER;
extern const VTFT_OT_EVETEXT;




extern const VTFT_EVT_UP;
extern const VTFT_EVT_DOWN;
extern const VTFT_EVT_CLICK;
extern const VTFT_EVT_PRESS;




extern const VTFT_SNDACT_NONE;
extern const VTFT_SNDACT_PLAY;
extern const VTFT_SNDACT_STOP;




extern const VTFT_LOAD_RES_NONE;
extern const VTFT_LOAD_RES_STATIC;
extern const VTFT_LOAD_RES_DYNAMIC;
extern const VTFT_LOAD_RES_ALL;




extern const VTFT_DISPLAY_EFF_NONE;
extern const VTFT_DISPLAY_EFF_LIGHTS_FADE;
extern const VTFT_DISPLAY_EFF_LIGHTS_OFF;




extern const VTFT_INT_REPAINT_ON_DOWN;
extern const VTFT_INT_REPAINT_ON_UP;
extern const VTFT_INT_BRING_TO_FRONT;
extern const VTFT_INT_INTRINSIC_CLICK_EFF;




extern const TPointer DrawHandlerTable[44];



extern const TFT800PWM VTFT_FT800_CONFIG_PWM;
extern const TFT800GPIO VTFT_FT800_CONFIG_GPIO;
extern const TFT800Sound VTFT_FT800_CONFIG_SOUND;
extern const TFT800Audio VTFT_FT800_CONFIG_AUDIO;
extern const TFT800Display VTFT_FT800_CONFIG_DISPLAY;
extern const TFT800Interrupt VTFT_FT800_CONFIG_INTERRUPT;
extern const TFT800Touch VTFT_FT800_CONFIG_TOUCH;
extern const TFT800TouchTransform VTFT_FT800_CONFIG_TOUCHTRANSFORM;

extern TTouchStat TouchS;

extern TScreen Screen2;

extern TEveSlider EveSlider_Basisachse;
extern TEvent EveSlider_Basisachse_OnPress;
extern TEveSlider EveSlider_Achse2;
extern TEvent EveSlider_Achse2_OnPress;
extern TCircle Circle2;
extern TCircle Circle4;
extern TCircle Circle_Blase;
extern TEveText EveText2;
extern TEveText EveText3;
extern TLabel Label10;
extern TLabel Label3;
extern TLabel Label4;
extern TLabel Label1;
extern TLabel Label5;
extern TLabel Label6;
extern TLabel Label2;
extern TLabel Label7;
extern TLabel Label8;
extern TLabel Label9;
extern TLabel Label11;
extern TLabel Label12;
extern TLabel Label13;
extern TLabel Label14;

extern TLabel *const code Screen2_Labels[14];
extern TCircle *const code Screen2_Circles[3];
extern TEveSlider *const code Screen2_EveSliders[2];
extern TEveText *const code Screen2_EveTexts[2];

extern TScreen *CurrentScreen;



void EveSlider_Achse2OnPress();
void EveSlider_BasisachseOnPress();




extern char EveSlider_Basisachse_Caption[];
extern char EveSlider_Achse2_Caption[];
extern char Circle2_Caption[];
extern char Circle4_Caption[];
extern char Circle_Blase_Caption[];
extern char EveText2_Caption[];
extern char EveText3_Caption[];
extern char Label10_Caption[];
extern char Label3_Caption[];
extern char Label4_Caption[];
extern char Label1_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label2_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char Label9_Caption[];
extern char Label11_Caption[];
extern char Label12_Caption[];
extern char Label13_Caption[];
extern char Label14_Caption[];



extern TEvent EveSlider_Basisachse_OnUpOnPress;
extern TEvent EveSlider_Achse2_OnUpOnPress;


void DrawScreenO(TScreen *aScreen, char aOptions);
void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawCircle(TCircle *ACircle);
void DrawEveSlider(TEveSlider *AEveSlider);
void DrawEveText(TEveText *AEveText);
void ProcessVTFTStack();
void InitVTFTStack();
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/tft/tft eigene programme/libelle_eve/libelle_eve_code/mikroc pro for pic32/libelle_eve_resources.h"



const code char Tahoma_13x16_Regular[];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/built_in.h"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/tft/tft eigene programme/libelle_eve/libelle_eve_code/mikroc pro for pic32/ft800_types.h"
#line 8 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/TFT/TFT eigene Programme/libelle_eve/libelle_eve_Code/mikroC PRO for PIC32/libelle_eve_driver.c"
sbit FT800_RST at LATC1_bit;
sbit FT800_CS at LATC2_bit;
sbit FT800_RST_Direction at TRISC1_bit;
sbit FT800_CS_Direction at TRISC2_bit;




const VTFT_OT_LABEL = 4;
const VTFT_OT_CIRCLE = 8;
const VTFT_OT_EVESLIDER = 32;
const VTFT_OT_EVETEXT = 40;




const VTFT_EVT_UP = 0;
const VTFT_EVT_DOWN = 1;
const VTFT_EVT_CLICK = 2;
const VTFT_EVT_PRESS = 3;




const VTFT_SNDACT_NONE = 0;
const VTFT_SNDACT_PLAY = 1;
const VTFT_SNDACT_STOP = 2;




const VTFT_LOAD_RES_NONE = 0x00;
const VTFT_LOAD_RES_STATIC = 0x01;
const VTFT_LOAD_RES_DYNAMIC = 0x02;
const VTFT_LOAD_RES_ALL = 0x03;




const VTFT_DISPLAY_EFF_NONE = 0x00;
const VTFT_DISPLAY_EFF_LIGHTS_FADE = 0x04;
const VTFT_DISPLAY_EFF_LIGHTS_OFF = 0x08;




const VTFT_INT_REPAINT_ON_DOWN = 1 << 0;
const VTFT_INT_REPAINT_ON_UP = 1 << 1;
const VTFT_INT_BRING_TO_FRONT = 1 << 2;
const VTFT_INT_INTRINSIC_CLICK_EFF = 1 << 3;




const TPointer DrawHandlerTable[44] = {
 0,
 0,
 0,
 0,
 &DrawLabel,
 0,
 0,
 0,
 &DrawCircle,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 &DrawEveSlider,
 0,
 0,
 0,
 0,
 0,
 0,
 0,
 &DrawEveText,
 0,
 0,
 0
};



const TFT800Display VTFT_FT800_CONFIG_DISPLAY =
{
 48000000,
 0,
 0,
 0,
 525,
 43,
 480,
 0,
 41,
 286,
 12,
 272,
 0,
 10,
 0,
 0x01B6,
 0,
 0x0000,
 0,
 1,
 5,
};

const TFT800Touch VTFT_FT800_CONFIG_TOUCH =
{
 3,
 1,
 5000,
 3,
 7,
 1500,
};

const TFT800TouchTransform VTFT_FT800_CONFIG_TOUCHTRANSFORM =
{
 0x00008128,
 0xFFFFFe4d,
 0xFFED5516,
 0xFFFFFE94,
 0x00004C78,
 0xFFF095AB,
};

const TFT800GPIO VTFT_FT800_CONFIG_GPIO =
{
 0xFC,
 0xFF,
};

const TFT800PWM VTFT_FT800_CONFIG_PWM =
{
 250,
 128,
};

const TFT800Interrupt VTFT_FT800_CONFIG_INTERRUPT =
{
 0,
 255,
 0,
};

const TFT800Sound VTFT_FT800_CONFIG_SOUND =
{
 0,
 0,
 0,
 0,
};

const TFT800Audio VTFT_FT800_CONFIG_AUDIO =
{
 0,
 0,
 8000,
 0,
 0,
 0,
 0,
};



TTouchStat TouchS = {0};



TScreen *CurrentScreen = 0;


TScreen Screen2;

TEveSlider EveSlider_Basisachse;
TEvent EveSlider_Basisachse_OnPress;
TEveSlider EveSlider_Achse2;
TEvent EveSlider_Achse2_OnPress;
TCircle Circle2;
TCircle Circle4;
TCircle Circle_Blase;
TEveText EveText2;
char EveText2_Caption[11] = "Basisachse";
TEveText EveText3;
char EveText3_Caption[8] = "Achse 2";
TLabel Label10;
char Label10_Caption[38] = "center = from left 320 / from top 120";
TLabel Label3;
char Label3_Caption[9] = "Text";
TLabel Label4;
char Label4_Caption[9] = "Text";
TLabel Label1;
char Label1_Caption[9] = "Text";
TLabel Label5;
char Label5_Caption[9] = "Text";
TLabel Label6;
char Label6_Caption[9] = "Text";
TLabel Label2;
char Label2_Caption[9] = "Text";
TLabel Label7;
char Label7_Caption[2] = "C";
TLabel Label8;
char Label8_Caption[2] = "A";
TLabel Label9;
char Label9_Caption[2] = "B";
TLabel Label11;
char Label11_Caption[2] = "F";
TLabel Label12;
char Label12_Caption[2] = "D";
TLabel Label13;
char Label13_Caption[2] = "E";
TLabel Label14;
char Label14_Caption[25] = "Scanned touch variables:";

TLabel *const code Screen2_Labels[14] = {
 &Label10,
 &Label3,
 &Label4,
 &Label1,
 &Label5,
 &Label6,
 &Label2,
 &Label7,
 &Label8,
 &Label9,
 &Label11,
 &Label12,
 &Label13,
 &Label14
};

TCircle *const code Screen2_Circles[3] = {
 &Circle2,
 &Circle4,
 &Circle_Blase
};

TEveSlider *const code Screen2_EveSliders[2] = {
 &EveSlider_Basisachse,
 &EveSlider_Achse2
};

TEveText *const code Screen2_EveTexts[2] = {
 &EveText2,
 &EveText3
};


static char IsInsideObject(TObjInfo *AObjInfo, unsigned int X, unsigned int Y) {
 TRect *ptrPressRect = 0;
 TRect *ptrPressCircle = 0;

 if ((AObjInfo->HitX == X) && (AObjInfo->HitY == Y))
 return 1;

 switch (AObjInfo->Type) {

 case VTFT_OT_LABEL: {
 ptrPressRect = (TRect *)&(((TLabel *)AObjInfo->Obj)->Left);
 break;
 }

 case VTFT_OT_CIRCLE: {
 ptrPressCircle = (TRect *)&(((TCircle *)AObjInfo->Obj)->Left);
 break;
 }

 case VTFT_OT_EVESLIDER: {
 ptrPressRect = (TRect *)&(((TEveSlider *)AObjInfo->Obj)->Left);
 break;
 }

 case VTFT_OT_EVETEXT: {
 ptrPressRect = (TRect *)&(((TEveText *)AObjInfo->Obj)->Left);
 break;
 }
 }

 if (ptrPressRect) {
 if ((ptrPressRect->Left <= X) && (ptrPressRect->Left+ptrPressRect->Width-1 >= X) &&
 (ptrPressRect->Top <= Y) && (ptrPressRect->Top+ptrPressRect->Height-1 >= Y))
 return 1;
 }
 else if (ptrPressCircle) {
 if ((ptrPressCircle->Left <= X) && (ptrPressCircle->Left+ptrPressCircle->Width*2-1 >= X) &&
 (ptrPressCircle->Top <= Y) && (ptrPressCircle->Top+ptrPressCircle->Width*2-1 >= Y))
 return 1;
 }

 return 0;
}

void DrawLabel(TLabel *ALabel) {
 if (ALabel->Visible) {
 if (ALabel->FontHandle >= 16)
 FT800_Canvas_FontSystem(ALabel->FontHandle, ALabel->Font_Color, ALabel->Opacity);
 else
 FT800_Canvas_Font(ALabel->FontHandle, ALabel->FontName, ALabel->Source, ALabel->Font_Color, ALabel->Opacity);

 if (ALabel->Tag)
 FT800_Canvas_Tag(ALabel->Tag);

 FT800_Screen_TextPos(ALabel->Left, ALabel->Top, ALabel->Caption);
 }
}

void DrawCircle(TCircle *ACircle) {
 if (ACircle->Visible) {
 if (ACircle == (TCircle *)TouchS.ActObjInfo.Obj)
 FT800_Canvas_BrushSingleColor(_FT800_BRUSH_STYLE_SOLID, ACircle->Press_Color, ACircle->Opacity);
 else
 FT800_Canvas_BrushSingleColor(_FT800_BRUSH_STYLE_SOLID, ACircle->Color, ACircle->Opacity);

 FT800_Canvas_Pen(ACircle->Pen_Width, ACircle->Pen_Color, ACircle->Opacity);

 if (ACircle->Tag)
 FT800_Canvas_Tag(ACircle->Tag);

 FT800_Screen_Circle(ACircle->Left+ACircle->Radius,
 ACircle->Top+ACircle->Radius,
 ACircle->Radius);
 }
}

void DrawEveSlider(TEveSlider *AEveSlider) {
 unsigned long drawOptions;

 if (AEveSlider->Visible) {
 if (AEveSlider == (TEveSlider *)TouchS.ActObjInfo.Obj)
 FT800_Canvas_BrushDualColor(_FT800_BRUSH_STYLE_SOLID, AEveSlider->Press_Color, AEveSlider->Thumb_Color, AEveSlider->Opacity);
 else
 FT800_Canvas_BrushDualColor(_FT800_BRUSH_STYLE_SOLID, AEveSlider->Background_Color, AEveSlider->Thumb_Color, AEveSlider->Opacity);

 FT800_Canvas_Pen(1, AEveSlider->Color, AEveSlider->Opacity);

 FT800_Canvas_CPGraphics_Range(AEveSlider->Range);

 FT800_Canvas_CPGraphics_Value(AEveSlider->Value);

 if (AEveSlider->Tag)
 FT800_Canvas_Tag(AEveSlider->Tag);

 drawOptions = 0;
 if (AEveSlider->Flat)
 drawOptions |= _FT800_CP_DRAW_OPT_FLAT;
 FT800_Canvas_CPGraphics_DrawingOptions(drawOptions);

 FT800_Screen_SliderCP(AEveSlider->Left, AEveSlider->Top, AEveSlider->Width, AEveSlider->Height);
 }
}

void DrawEveText(TEveText *AEveText) {
 unsigned long drawOptions;

 if (AEveText->Visible) {
 if (AEveText->FontHandle >= 16)
 FT800_Canvas_FontSystem(AEveText->FontHandle, AEveText->Font_Color, AEveText->Opacity);
 else
 FT800_Canvas_Font(AEveText->FontHandle, AEveText->FontName, AEveText->Source, AEveText->Font_Color, AEveText->Opacity);

 if (AEveText->Tag)
 FT800_Canvas_Tag(AEveText->Tag);

 drawOptions = 0;
 if (AEveText->TextAlign == taCenter)
 drawOptions |= _FT800_CP_DRAW_OPT_CENTER;
 else if (AEveText->TextAlign == taCenterX)
 drawOptions |= _FT800_CP_DRAW_OPT_CENTERX;
 else if (AEveText->TextAlign == taCenterY)
 drawOptions |= _FT800_CP_DRAW_OPT_CENTERY;
 else if (AEveText->TextAlign == taRightX)
 drawOptions |= _FT800_CP_DRAW_OPT_RIGHTX;
 FT800_Canvas_CPGraphics_DrawingOptions(drawOptions);

 FT800_Screen_TextCP(AEveText->Left, AEveText->Top, AEveText->Caption);
 }
}

void SetIdenticalFontSources(const code char *AFontName, unsigned long ASource) {
 char i;
 TLabel *pLabel;
 TEveText *pEveText;
 void *const code *ptrO;


 i = CurrentScreen->LabelsCount;
 ptrO = CurrentScreen->Labels;
 while (i--) {
 pLabel = (TLabel *)(*ptrO);
 if (pLabel->FontName == AFontName)
 pLabel->Source = ASource;
 ptrO++;
 }


 i = CurrentScreen->EveTextsCount;
 ptrO = CurrentScreen->EveTexts;
 while (i--) {
 pEveText = (TEveText *)(*ptrO);
 if (pEveText->FontName == AFontName)
 pEveText->Source = ASource;
 ptrO++;
 }
}

static void ClearDynObjSource() {
 char i;
 TLabel *pLabel;
 TEveText *pEveText;
 void *const code *ptrO;


 i = CurrentScreen->LabelsCount;
 ptrO = CurrentScreen->Labels;
 while (i--) {
 pLabel = (TLabel *)(*ptrO);
 pLabel->Source = 0xFFFFFFFF;
 ptrO++;
 }


 i = CurrentScreen->EveTextsCount;
 ptrO = CurrentScreen->EveTexts;
 while (i--) {
 pEveText = (TEveText *)(*ptrO);
 pEveText->Source = 0xFFFFFFFF;
 ptrO++;
 }
}

void LoadCurrentScreenResToGRAM(char loadOptions) {
 char i;
 long currSource = -1;
 TLabel *pLabel;
 TEveText *pEveText;
 void *const code *ptrO;


 if (loadOptions & VTFT_LOAD_RES_DYNAMIC)
 ClearDynObjSource();


 if (loadOptions & VTFT_LOAD_RES_DYNAMIC) {

 if (FT800_RES_BeginLoad(CurrentScreen->DynResStart)) {
 return;
 }


 i = CurrentScreen->LabelsCount;
 ptrO = CurrentScreen->Labels;
 while (i--) {
 pLabel = (TLabel *)(*ptrO);
 if (pLabel->FontHandle < 16)
 if (pLabel->Source == 0xFFFFFFFF) {
 currSource = FT800_Res_LoadFont(pLabel->FontName);
 pLabel->Source = currSource;
 SetIdenticalFontSources(pLabel->FontName, currSource);
 }
 ptrO++;
 }


 i = CurrentScreen->EveTextsCount;
 ptrO = CurrentScreen->EveTexts;
 while (i--) {
 pEveText = (TEveText *)(*ptrO);
 if (pEveText->FontHandle < 16)
 if (pEveText->Source == 0xFFFFFFFF) {
 currSource = FT800_Res_LoadFont(pEveText->FontName);
 pEveText->Source = currSource;
 SetIdenticalFontSources(pEveText->FontName, currSource);
 }
 ptrO++;
 }

 FT800_RES_EndLoad();
 }
}

void DrawObject(TPointer aObj, char aObjType) {
 TDrawHandler drawHandler;

 drawHandler = DrawHandlerTable[aObjType];
 if (drawHandler)
 drawHandler(aObj);
}

void DrawScreenO(TScreen *aScreen, char aOptions) {
 unsigned short cOrder, saveOrder;
 signed int actObjOrder;
 unsigned short pwmDuty;

 char cntLabel;
 char cntCircle;
 char cntEveSlider;
 char cntEveText;

 TLabel *const code *pLabel;
 TCircle *const code *pCircle;
 TEveSlider *const code *pEveSlider;
 TEveText *const code *pEveText;


 if (aOptions & VTFT_DISPLAY_EFF_LIGHTS_FADE) {
 FT800_PWM_Get(0, &pwmDuty);
 FT800_PWM_FadeOut(pwmDuty, 0, pwmDuty/32? pwmDuty/32 : 1, 1);
 }
 else if (aOptions & VTFT_DISPLAY_EFF_LIGHTS_OFF) {
 FT800_PWM_Get(0, &pwmDuty);
 FT800_PWM_Duty(0);
 }


 if (CurrentScreen != aScreen)
 memset(&TouchS.ActObjInfo, 0, sizeof(TObjInfo));

 CurrentScreen = aScreen;

 LoadCurrentScreenResToGRAM(aOptions);


 cntLabel = CurrentScreen->LabelsCount;
 cntCircle = CurrentScreen->CirclesCount;
 cntEveSlider = CurrentScreen->EveSlidersCount;
 cntEveText = CurrentScreen->EveTextsCount;

 pLabel = CurrentScreen->Labels;
 pCircle = CurrentScreen->Circles;
 pEveSlider = CurrentScreen->EveSliders;
 pEveText = CurrentScreen->EveTexts;

 FT800_Screen_BeginUpdateCP();
 FT800_Canvas_BrushSingleColor(_FT800_BRUSH_STYLE_SOLID, CurrentScreen->Color, 255);
 FT800_Canvas_Tag(0);
 FT800_Screen_Clear(_FT800_CLEAR_ALL);

 actObjOrder = -1;
 if (TouchS.ActObjInfo.Obj)
 if (TouchS.ActObjInfo.Flags & VTFT_INT_BRING_TO_FRONT)
 actObjOrder = TouchS.ActObjInfo.Order;

 cOrder = 0;
 while (cOrder < CurrentScreen->ObjectsCount) {
 saveOrder = cOrder;
 if (pLabel) {
 while ((*pLabel)->Order == cOrder) {
 if (actObjOrder != cOrder)
 DrawLabel(*pLabel);
 cOrder++;
 pLabel++;
 cntLabel--;
 if (!cntLabel) {
 pLabel = 0;
 break;
 }
 }
 if (saveOrder != cOrder)
 continue;
 }

 if (pCircle) {
 while ((*pCircle)->Order == cOrder) {
 if (actObjOrder != cOrder)
 DrawCircle(*pCircle);
 cOrder++;
 pCircle++;
 cntCircle--;
 if (!cntCircle) {
 pCircle = 0;
 break;
 }
 }
 if (saveOrder != cOrder)
 continue;
 }

 if (pEveSlider) {
 while ((*pEveSlider)->Order == cOrder) {
 if (actObjOrder != cOrder)
 DrawEveSlider(*pEveSlider);
 cOrder++;
 pEveSlider++;
 cntEveSlider--;
 if (!cntEveSlider) {
 pEveSlider = 0;
 break;
 }
 }
 if (saveOrder != cOrder)
 continue;
 }

 if (pEveText) {
 while ((*pEveText)->Order == cOrder) {
 if (actObjOrder != cOrder)
 DrawEveText(*pEveText);
 cOrder++;
 pEveText++;
 cntEveText--;
 if (!cntEveText) {
 pEveText = 0;
 break;
 }
 }
 if (saveOrder != cOrder)
 continue;
 }

 cOrder++;
 }


 if (TouchS.ActObjInfo.Obj)
 DrawObject(TouchS.ActObjInfo.Obj, TouchS.ActObjInfo.Type);

 FT800_Screen_EndUpdate();

 FT800_Screen_Show();


 if (aOptions & VTFT_DISPLAY_EFF_LIGHTS_FADE) {
 FT800_PWM_FadeIn(0, pwmDuty, 1, 3);
 }
 else if (aOptions & VTFT_DISPLAY_EFF_LIGHTS_OFF) {
 FT800_PWM_Duty(pwmDuty);
 }

}

void DrawScreen(TScreen *aScreen) {
 if (aScreen != CurrentScreen)
 DrawScreenO(aScreen, VTFT_LOAD_RES_ALL | VTFT_DISPLAY_EFF_LIGHTS_FADE);
 else
 DrawScreenO(aScreen, VTFT_LOAD_RES_NONE);
}

char GetActiveObjectByXY(int X, int Y, TObjInfo *AObjInfo) {
 char i;
 int hiOrder;
 TLabel *pLabel;
 TCircle *pCircle;
 TEveSlider *pEveSlider;
 TEveText *pEveText;
 void *const code *ptrO;


 memset(AObjInfo, 0, sizeof(TObjInfo));



 hiOrder = -1;


 i = CurrentScreen->LabelsCount;
 ptrO = CurrentScreen->Labels+CurrentScreen->LabelsCount-1;
 while (i--) {
 pLabel = (TLabel *)(*ptrO);
 if (pLabel->Order < hiOrder)
 break;
 if (pLabel->Active) {
 if ((pLabel->Left <= X) && (pLabel->Left+pLabel->Width-1 >= X) &&
 (pLabel->Top <= Y) && (pLabel->Top+pLabel->Height-1 >= Y)) {
 AObjInfo->Obj = (void *)pLabel;
 AObjInfo->Type = VTFT_OT_LABEL;
 AObjInfo->Order = pLabel->Order;
 AObjInfo->Flags = VTFT_INT_BRING_TO_FRONT;
 hiOrder = pLabel->Order;
 break;
 }
 }
 ptrO--;
 }


 i = CurrentScreen->CirclesCount;
 ptrO = CurrentScreen->Circles+CurrentScreen->CirclesCount-1;
 while (i--) {
 pCircle = (TCircle *)(*ptrO);
 if (pCircle->Order < hiOrder)
 break;
 if (pCircle->Active) {

 if ((pCircle->Left <= X) && (pCircle->Left+pCircle->Radius*2-1 >= X) &&
 (pCircle->Top <= Y) && (pCircle->Top+pCircle->Radius*2-1 >= Y)) {
 AObjInfo->Obj = (void *)pCircle;
 AObjInfo->Type = VTFT_OT_CIRCLE;
 AObjInfo->Order = pCircle->Order;
 AObjInfo->Flags = VTFT_INT_BRING_TO_FRONT;
 if (pCircle->Press_Color != pCircle->Color)
 AObjInfo->Flags |= VTFT_INT_REPAINT_ON_DOWN | VTFT_INT_REPAINT_ON_UP;
 hiOrder = pCircle->Order;
 break;
 }
 }
 ptrO--;
 }


 i = CurrentScreen->EveSlidersCount;
 ptrO = CurrentScreen->EveSliders+CurrentScreen->EveSlidersCount-1;
 while (i--) {
 pEveSlider = (TEveSlider *)(*ptrO);
 if (pEveSlider->Order < hiOrder)
 break;
 if (pEveSlider->Active) {
 if ((pEveSlider->Left <= X) && (pEveSlider->Left+pEveSlider->Width-1 >= X) &&
 (pEveSlider->Top <= Y) && (pEveSlider->Top+pEveSlider->Height-1 >= Y)) {
 AObjInfo->Obj = (void *)pEveSlider;
 AObjInfo->Type = VTFT_OT_EVESLIDER;
 AObjInfo->Order = pEveSlider->Order;
 AObjInfo->Flags = VTFT_INT_BRING_TO_FRONT;
 if (pEveSlider->Press_Color != pEveSlider->Color)
 AObjInfo->Flags |= VTFT_INT_REPAINT_ON_DOWN | VTFT_INT_REPAINT_ON_UP;
 hiOrder = pEveSlider->Order;
 break;
 }
 }
 ptrO--;
 }


 i = CurrentScreen->EveTextsCount;
 ptrO = CurrentScreen->EveTexts+CurrentScreen->EveTextsCount-1;
 while (i--) {
 pEveText = (TEveText *)(*ptrO);
 if (pEveText->Order < hiOrder)
 break;
 if (pEveText->Active) {
 if ((pEveText->Left <= X) && (pEveText->Left+pEveText->Width-1 >= X) &&
 (pEveText->Top <= Y) && (pEveText->Top+pEveText->Height-1 >= Y)) {
 AObjInfo->Obj = (void *)pEveText;
 AObjInfo->Type = VTFT_OT_EVETEXT;
 AObjInfo->Order = pEveText->Order;
 AObjInfo->Flags = VTFT_INT_BRING_TO_FRONT;
 hiOrder = pEveText->Order;
 break;
 }
 }
 ptrO--;
 }

 if (AObjInfo->Obj) {
 AObjInfo->HitX = X;
 AObjInfo->HitY = Y;
 return 1;
 }
 else {
 return 0;
 }
}

char GetActiveObjectByTag(char ATag, TObjInfo *AObjInfo) {
 char i;
 TLabel *pLabel;
 TCircle *pCircle;
 TEveSlider *pEveSlider;
 TEveText *pEveText;
 void *const code *ptrO;


 memset(AObjInfo, 0, sizeof(TObjInfo));




 i = CurrentScreen->LabelsCount;
 ptrO = CurrentScreen->Labels+CurrentScreen->LabelsCount-1;
 while (i--) {
 pLabel = (TLabel *)(*ptrO);
 if (pLabel->Tag == ATag) {
 if (pLabel->Active) {
 AObjInfo->Obj = (void *)pLabel;
 AObjInfo->Type = VTFT_OT_LABEL;
 AObjInfo->Order = pLabel->Order;
 AObjInfo->Flags = VTFT_INT_BRING_TO_FRONT;
 }
 break;
 }
 ptrO--;
 }


 i = CurrentScreen->CirclesCount;
 ptrO = CurrentScreen->Circles+CurrentScreen->CirclesCount-1;
 while (i--) {
 pCircle = (TCircle *)(*ptrO);
 if (pCircle->Tag == ATag) {
 if (pCircle->Active) {
 AObjInfo->Obj = (void *)pCircle;
 AObjInfo->Type = VTFT_OT_CIRCLE;
 AObjInfo->Order = pCircle->Order;
 AObjInfo->Flags = VTFT_INT_BRING_TO_FRONT;
 if (pCircle->Press_Color != pCircle->Color)
 AObjInfo->Flags |= VTFT_INT_REPAINT_ON_DOWN | VTFT_INT_REPAINT_ON_UP;

 }
 break;
 }
 ptrO--;
 }


 i = CurrentScreen->EveSlidersCount;
 ptrO = CurrentScreen->EveSliders+CurrentScreen->EveSlidersCount-1;
 while (i--) {
 pEveSlider = (TEveSlider *)(*ptrO);
 if (pEveSlider->Tag == ATag) {
 if (pEveSlider->Active) {
 AObjInfo->Obj = (void *)pEveSlider;
 AObjInfo->Type = VTFT_OT_EVESLIDER;
 AObjInfo->Order = pEveSlider->Order;
 AObjInfo->Flags = VTFT_INT_BRING_TO_FRONT;
 if (pEveSlider->Press_Color != pEveSlider->Color)
 AObjInfo->Flags |= VTFT_INT_REPAINT_ON_DOWN | VTFT_INT_REPAINT_ON_UP;

 }
 break;
 }
 ptrO--;
 }


 i = CurrentScreen->EveTextsCount;
 ptrO = CurrentScreen->EveTexts+CurrentScreen->EveTextsCount-1;
 while (i--) {
 pEveText = (TEveText *)(*ptrO);
 if (pEveText->Tag == ATag) {
 if (pEveText->Active) {
 AObjInfo->Obj = (void *)pEveText;
 AObjInfo->Type = VTFT_OT_EVETEXT;
 AObjInfo->Order = pEveText->Order;
 AObjInfo->Flags = VTFT_INT_BRING_TO_FRONT;
 }
 break;
 }
 ptrO--;
 }

 if (AObjInfo->Obj) {
 AObjInfo->HitTag = ATag;
 return 1;
 }
 else {
 return 0;
 }
}

static void ProcessEvent(TEvent *pEvent) {
 if (pEvent) {
 if (pEvent->Sound.SndAct == VTFT_SNDACT_PLAY)
 FT800_Sound_SetAndPlay(pEvent->Sound.Effect, pEvent->Sound.Pitch, pEvent->Sound.Volume);
 else if (pEvent->Sound.SndAct == VTFT_SNDACT_STOP)
 FT800_Sound_Stop();
 if (pEvent->Action)
 pEvent->Action();
 }
}

static void ProcessCEvent(TCEvent *pEventC) {
 if (pEventC) {
 if (pEventC->Sound.SndAct == VTFT_SNDACT_PLAY)
 FT800_Sound_SetAndPlay(pEventC->Sound.Effect, pEventC->Sound.Pitch, pEventC->Sound.Volume);
 else if (pEventC->Sound.SndAct == VTFT_SNDACT_STOP)
 FT800_Sound_Stop();
 if (pEventC->Action)
 pEventC->Action();
 }
}

static void OnEvent(TObjInfo *AObjInfo, char AEventType){
 TEvent **ppEvent;
 TEvent *pEvent = 0;

 switch (AObjInfo->Type) {

 case VTFT_OT_LABEL: {
 ppEvent = &(((TLabel *)AObjInfo->Obj)->OnUp);
 pEvent = ppEvent[AEventType];
 break;
 }

 case VTFT_OT_CIRCLE: {
 ppEvent = &(((TCircle *)AObjInfo->Obj)->OnUp);
 pEvent = ppEvent[AEventType];
 break;
 }

 case VTFT_OT_EVESLIDER: {
 ppEvent = &(((TEveSlider *)AObjInfo->Obj)->OnUp);
 pEvent = ppEvent[AEventType];
 break;
 }

 case VTFT_OT_EVETEXT: {
 ppEvent = &(((TEveText *)AObjInfo->Obj)->OnUp);
 pEvent = ppEvent[AEventType];
 break;
 }
 }

 if (pEvent) {
 ProcessEvent(pEvent);
 }
}

static void Process_TP_Press() {

 if (CurrentScreen->Active)
 if ((CurrentScreen->SniffObjectEvents) || (!TouchS.ActObjInfo.Obj))
 ProcessEvent(CurrentScreen->OnPress);


 if (!TouchS.ActObjInfo.Obj)
 return;

 OnEvent(&TouchS.ActObjInfo, VTFT_EVT_PRESS);
}

static void Process_TP_Up() {
 char isClick;
 TObjInfo actObj;


 if (CurrentScreen->Active)
 if ((CurrentScreen->SniffObjectEvents) || (!TouchS.ActObjInfo.Obj))
 ProcessEvent(CurrentScreen->OnUp);

 actObj = TouchS.ActObjInfo;

 memset(&TouchS.ActObjInfo, 0, sizeof(TObjInfo));


 if (!actObj.Obj)
 return;

 isClick = IsInsideObject(&actObj, TouchS.X, TouchS.Y);

 if (actObj.Flags & VTFT_INT_REPAINT_ON_UP)
 DrawScreen(CurrentScreen);

 OnEvent(&actObj, VTFT_EVT_UP);
 if (isClick)
 OnEvent(&actObj, VTFT_EVT_CLICK);
}

static void Process_TP_Down() {

 if (TouchS.Tag) {
 if (TouchS.Tag != 255)
 GetActiveObjectByTag(TouchS.Tag, &TouchS.ActObjInfo);
 if (!TouchS.ActObjInfo.Obj)
 GetActiveObjectByXY(TouchS.X, TouchS.Y, &TouchS.ActObjInfo);
 }


 if (CurrentScreen->Active)
 if ((CurrentScreen->SniffObjectEvents) || (!TouchS.ActObjInfo.Obj))
 ProcessEvent(CurrentScreen->OnDown);


 if (!TouchS.ActObjInfo.Obj)
 return;

 if (TouchS.ActObjInfo.Flags & VTFT_INT_REPAINT_ON_DOWN)
 DrawScreen(CurrentScreen);

 OnEvent(&TouchS.ActObjInfo, VTFT_EVT_DOWN);
}

static void Process_TP_TagChange() {

 if (CurrentScreen->Active)
 ProcessEvent(CurrentScreen->OnTagChange);
}

void ProcessVTFTStack() {
 char Tag, oldTag;
 unsigned int X, Y;

 oldTag = TouchS.Tag;

 if (FT800_Touch_GetTagXY(&X, &Y) == 1) {
 FT800_Touch_GetTag(&Tag);

 TouchS.Tag = Tag;
 TouchS.X = X;
 TouchS.Y = Y;

 if (!TouchS.Pressed) {
 TouchS.Pressed = 1;
 Process_TP_Down();
 }

 Process_TP_Press();
 }
 else if (TouchS.Pressed) {
 Process_TP_Up();

 TouchS.Tag = 0;
 TouchS.X = X;
 TouchS.Y = Y;

 TouchS.Pressed = 0;
 }

 if (oldTag != TouchS.Tag)
 Process_TP_TagChange();
}

static void InitObjects() {

 Screen2.Color = 0xC618;
 Screen2.Width = 480;
 Screen2.Height = 272;
 Screen2.ObjectsCount = 21;
 Screen2.LabelsCount = 14;
 Screen2.Labels = Screen2_Labels;
 Screen2.CirclesCount = 3;
 Screen2.Circles = Screen2_Circles;
 Screen2.EveSlidersCount = 2;
 Screen2.EveSliders = Screen2_EveSliders;
 Screen2.EveTextsCount = 2;
 Screen2.EveTexts = Screen2_EveTexts;
 Screen2.DynResStart = 0;
 Screen2.Active = 1;
 Screen2.SniffObjectEvents = 0;
 Screen2.OnUp = 0;
 Screen2.OnDown = 0;
 Screen2.OnTagChange = 0;
 Screen2.OnPress = 0;

 EveSlider_Basisachse.OwnerScreen = &Screen2;
 EveSlider_Basisachse.Order = 0;
 EveSlider_Basisachse.Visible = 1;
 EveSlider_Basisachse.Opacity = 255;
 EveSlider_Basisachse.Tag = 255;
 EveSlider_Basisachse.Left = 40;
 EveSlider_Basisachse.Top = 152;
 EveSlider_Basisachse.Width = 137;
 EveSlider_Basisachse.Height = 19;
 EveSlider_Basisachse.Background_Color = 0x03DA;
 EveSlider_Basisachse.Thumb_Color = 0xFFFF;
 EveSlider_Basisachse.Color = 0x0148;
 EveSlider_Basisachse.Press_Color = 0x7E3F;
 EveSlider_Basisachse.Value = 0;
 EveSlider_Basisachse.Range = 100;
 EveSlider_Basisachse.Flat = 0;
 EveSlider_Basisachse.Active = 1;
 EveSlider_Basisachse.OnUp = 0;
 EveSlider_Basisachse.OnDown = 0;
 EveSlider_Basisachse.OnClick = 0;
 EveSlider_Basisachse.OnPress = &EveSlider_Basisachse_OnPress;

 EveSlider_Basisachse_OnPress.Action = EveSlider_BasisachseOnPress;
 EveSlider_Basisachse_OnPress.Sound.SndAct = VTFT_SNDACT_NONE;
 EveSlider_Basisachse_OnPress.Sound.Effect = _FT800_SOUND_XYLOPHONE;
 EveSlider_Basisachse_OnPress.Sound.Pitch = _FT800_SOUND_PITCH_A5;
 EveSlider_Basisachse_OnPress.Sound.Volume = 255;

 EveSlider_Achse2.OwnerScreen = &Screen2;
 EveSlider_Achse2.Order = 1;
 EveSlider_Achse2.Visible = 1;
 EveSlider_Achse2.Opacity = 255;
 EveSlider_Achse2.Tag = 255;
 EveSlider_Achse2.Left = 42;
 EveSlider_Achse2.Top = 227;
 EveSlider_Achse2.Width = 140;
 EveSlider_Achse2.Height = 19;
 EveSlider_Achse2.Background_Color = 0x03DA;
 EveSlider_Achse2.Thumb_Color = 0xFFFF;
 EveSlider_Achse2.Color = 0x0148;
 EveSlider_Achse2.Press_Color = 0x7E3F;
 EveSlider_Achse2.Value = 0;
 EveSlider_Achse2.Range = 100;
 EveSlider_Achse2.Flat = 0;
 EveSlider_Achse2.Active = 1;
 EveSlider_Achse2.OnUp = 0;
 EveSlider_Achse2.OnDown = 0;
 EveSlider_Achse2.OnClick = 0;
 EveSlider_Achse2.OnPress = &EveSlider_Achse2_OnPress;

 EveSlider_Achse2_OnPress.Action = EveSlider_Achse2OnPress;
 EveSlider_Achse2_OnPress.Sound.SndAct = VTFT_SNDACT_NONE;
 EveSlider_Achse2_OnPress.Sound.Effect = _FT800_SOUND_XYLOPHONE;
 EveSlider_Achse2_OnPress.Sound.Pitch = _FT800_SOUND_PITCH_A5;
 EveSlider_Achse2_OnPress.Sound.Volume = 255;

 Circle2.OwnerScreen = &Screen2;
 Circle2.Order = 2;
 Circle2.Visible = 1;
 Circle2.Opacity = 255;
 Circle2.Tag = 255;
 Circle2.Left = 250;
 Circle2.Top = 50;
 Circle2.Radius = 70;
 Circle2.Pen_Width = 1;
 Circle2.Pen_Color = 0x0000;
 Circle2.Color = 0xFFE0;
 Circle2.Press_Color = 0xE71C;
 Circle2.Active = 1;
 Circle2.OnUp = 0;
 Circle2.OnDown = 0;
 Circle2.OnClick = 0;
 Circle2.OnPress = 0;

 Circle4.OwnerScreen = &Screen2;
 Circle4.Order = 3;
 Circle4.Visible = 1;
 Circle4.Opacity = 255;
 Circle4.Tag = 255;
 Circle4.Left = 304;
 Circle4.Top = 104;
 Circle4.Radius = 16;
 Circle4.Pen_Width = 1;
 Circle4.Pen_Color = 0x0000;
 Circle4.Color = 0xFFE0;
 Circle4.Press_Color = 0xE71C;
 Circle4.Active = 1;
 Circle4.OnUp = 0;
 Circle4.OnDown = 0;
 Circle4.OnClick = 0;
 Circle4.OnPress = 0;

 Circle_Blase.OwnerScreen = &Screen2;
 Circle_Blase.Order = 4;
 Circle_Blase.Visible = 1;
 Circle_Blase.Opacity = 255;
 Circle_Blase.Tag = 255;
 Circle_Blase.Left = 299;
 Circle_Blase.Top = 121;
 Circle_Blase.Radius = 10;
 Circle_Blase.Pen_Width = 1;
 Circle_Blase.Pen_Color = 0x0000;
 Circle_Blase.Color = 0x8410;
 Circle_Blase.Press_Color = 0xE71C;
 Circle_Blase.Active = 1;
 Circle_Blase.OnUp = 0;
 Circle_Blase.OnDown = 0;
 Circle_Blase.OnClick = 0;
 Circle_Blase.OnPress = 0;

 EveText2.OwnerScreen = &Screen2;
 EveText2.Order = 5;
 EveText2.Visible = 1;
 EveText2.Opacity = 255;
 EveText2.Tag = 255;
 EveText2.Left = 66;
 EveText2.Top = 127;
 EveText2.Width = 69;
 EveText2.Height = 17;
 EveText2.Caption = EveText2_Caption;
 EveText2.TextAlign = taNone;
 EveText2.FontName = 27;
 EveText2.Font_Color = 0x0148;
 EveText2.FontHandle = 27;
 EveText2.Source = -1UL;
 EveText2.Active = 1;
 EveText2.OnUp = 0;
 EveText2.OnDown = 0;
 EveText2.OnClick = 0;
 EveText2.OnPress = 0;

 EveText3.OwnerScreen = &Screen2;
 EveText3.Order = 6;
 EveText3.Visible = 1;
 EveText3.Opacity = 255;
 EveText3.Tag = 255;
 EveText3.Left = 78;
 EveText3.Top = 197;
 EveText3.Width = 48;
 EveText3.Height = 17;
 EveText3.Caption = EveText3_Caption;
 EveText3.TextAlign = taNone;
 EveText3.FontName = 27;
 EveText3.Font_Color = 0x0148;
 EveText3.FontHandle = 27;
 EveText3.Source = -1UL;
 EveText3.Active = 1;
 EveText3.OnUp = 0;
 EveText3.OnDown = 0;
 EveText3.OnClick = 0;
 EveText3.OnPress = 0;

 Label10.OwnerScreen = &Screen2;
 Label10.Order = 7;
 Label10.Visible = 1;
 Label10.Opacity = 255;
 Label10.Tag = 255;
 Label10.Left = 226;
 Label10.Top = 216;
 Label10.Width = 222;
 Label10.Height = 17;
 Label10.Caption = Label10_Caption;
 Label10.FontName = Tahoma_13x16_Regular;
 Label10.Font_Color = 0x0000;
 Label10.FontHandle = 1;
 Label10.Source = -1UL;
 Label10.Active = 1;
 Label10.OnUp = 0;
 Label10.OnDown = 0;
 Label10.OnClick = 0;
 Label10.OnPress = 0;

 Label3.OwnerScreen = &Screen2;
 Label3.Order = 8;
 Label3.Visible = 1;
 Label3.Opacity = 255;
 Label3.Tag = 255;
 Label3.Left = 38;
 Label3.Top = 84;
 Label3.Width = 26;
 Label3.Height = 17;
 Label3.Caption = Label3_Caption;
 Label3.FontName = Tahoma_13x16_Regular;
 Label3.Font_Color = 0x0000;
 Label3.FontHandle = 1;
 Label3.Source = -1UL;
 Label3.Active = 1;
 Label3.OnUp = 0;
 Label3.OnDown = 0;
 Label3.OnClick = 0;
 Label3.OnPress = 0;

 Label4.OwnerScreen = &Screen2;
 Label4.Order = 9;
 Label4.Visible = 1;
 Label4.Opacity = 255;
 Label4.Tag = 255;
 Label4.Left = 153;
 Label4.Top = 39;
 Label4.Width = 26;
 Label4.Height = 17;
 Label4.Caption = Label4_Caption;
 Label4.FontName = Tahoma_13x16_Regular;
 Label4.Font_Color = 0x0000;
 Label4.FontHandle = 1;
 Label4.Source = -1UL;
 Label4.Active = 1;
 Label4.OnUp = 0;
 Label4.OnDown = 0;
 Label4.OnClick = 0;
 Label4.OnPress = 0;

 Label1.OwnerScreen = &Screen2;
 Label1.Order = 10;
 Label1.Visible = 1;
 Label1.Opacity = 255;
 Label1.Tag = 255;
 Label1.Left = 38;
 Label1.Top = 39;
 Label1.Width = 26;
 Label1.Height = 17;
 Label1.Caption = Label1_Caption;
 Label1.FontName = Tahoma_13x16_Regular;
 Label1.Font_Color = 0x0000;
 Label1.FontHandle = 1;
 Label1.Source = -1UL;
 Label1.Active = 1;
 Label1.OnUp = 0;
 Label1.OnDown = 0;
 Label1.OnClick = 0;
 Label1.OnPress = 0;

 Label5.OwnerScreen = &Screen2;
 Label5.Order = 11;
 Label5.Visible = 1;
 Label5.Opacity = 255;
 Label5.Tag = 255;
 Label5.Left = 153;
 Label5.Top = 62;
 Label5.Width = 26;
 Label5.Height = 17;
 Label5.Caption = Label5_Caption;
 Label5.FontName = Tahoma_13x16_Regular;
 Label5.Font_Color = 0x0000;
 Label5.FontHandle = 1;
 Label5.Source = -1UL;
 Label5.Active = 1;
 Label5.OnUp = 0;
 Label5.OnDown = 0;
 Label5.OnClick = 0;
 Label5.OnPress = 0;

 Label6.OwnerScreen = &Screen2;
 Label6.Order = 12;
 Label6.Visible = 1;
 Label6.Opacity = 255;
 Label6.Tag = 255;
 Label6.Left = 153;
 Label6.Top = 84;
 Label6.Width = 26;
 Label6.Height = 17;
 Label6.Caption = Label6_Caption;
 Label6.FontName = Tahoma_13x16_Regular;
 Label6.Font_Color = 0x0000;
 Label6.FontHandle = 1;
 Label6.Source = -1UL;
 Label6.Active = 1;
 Label6.OnUp = 0;
 Label6.OnDown = 0;
 Label6.OnClick = 0;
 Label6.OnPress = 0;

 Label2.OwnerScreen = &Screen2;
 Label2.Order = 13;
 Label2.Visible = 1;
 Label2.Opacity = 255;
 Label2.Tag = 255;
 Label2.Left = 38;
 Label2.Top = 62;
 Label2.Width = 26;
 Label2.Height = 17;
 Label2.Caption = Label2_Caption;
 Label2.FontName = Tahoma_13x16_Regular;
 Label2.Font_Color = 0x0000;
 Label2.FontHandle = 1;
 Label2.Source = -1UL;
 Label2.Active = 1;
 Label2.OnUp = 0;
 Label2.OnDown = 0;
 Label2.OnClick = 0;
 Label2.OnPress = 0;

 Label7.OwnerScreen = &Screen2;
 Label7.Order = 14;
 Label7.Visible = 1;
 Label7.Opacity = 255;
 Label7.Tag = 255;
 Label7.Left = 24;
 Label7.Top = 84;
 Label7.Width = 8;
 Label7.Height = 17;
 Label7.Caption = Label7_Caption;
 Label7.FontName = Tahoma_13x16_Regular;
 Label7.Font_Color = 0x0000;
 Label7.FontHandle = 1;
 Label7.Source = -1UL;
 Label7.Active = 1;
 Label7.OnUp = 0;
 Label7.OnDown = 0;
 Label7.OnClick = 0;
 Label7.OnPress = 0;

 Label8.OwnerScreen = &Screen2;
 Label8.Order = 15;
 Label8.Visible = 1;
 Label8.Opacity = 255;
 Label8.Tag = 255;
 Label8.Left = 24;
 Label8.Top = 39;
 Label8.Width = 8;
 Label8.Height = 17;
 Label8.Caption = Label8_Caption;
 Label8.FontName = Tahoma_13x16_Regular;
 Label8.Font_Color = 0x0000;
 Label8.FontHandle = 1;
 Label8.Source = -1UL;
 Label8.Active = 1;
 Label8.OnUp = 0;
 Label8.OnDown = 0;
 Label8.OnClick = 0;
 Label8.OnPress = 0;

 Label9.OwnerScreen = &Screen2;
 Label9.Order = 16;
 Label9.Visible = 1;
 Label9.Opacity = 255;
 Label9.Tag = 255;
 Label9.Left = 24;
 Label9.Top = 62;
 Label9.Width = 8;
 Label9.Height = 17;
 Label9.Caption = Label9_Caption;
 Label9.FontName = Tahoma_13x16_Regular;
 Label9.Font_Color = 0x0000;
 Label9.FontHandle = 1;
 Label9.Source = -1UL;
 Label9.Active = 1;
 Label9.OnUp = 0;
 Label9.OnDown = 0;
 Label9.OnClick = 0;
 Label9.OnPress = 0;

 Label11.OwnerScreen = &Screen2;
 Label11.Order = 17;
 Label11.Visible = 1;
 Label11.Opacity = 255;
 Label11.Tag = 255;
 Label11.Left = 138;
 Label11.Top = 84;
 Label11.Width = 7;
 Label11.Height = 17;
 Label11.Caption = Label11_Caption;
 Label11.FontName = Tahoma_13x16_Regular;
 Label11.Font_Color = 0x0000;
 Label11.FontHandle = 1;
 Label11.Source = -1UL;
 Label11.Active = 1;
 Label11.OnUp = 0;
 Label11.OnDown = 0;
 Label11.OnClick = 0;
 Label11.OnPress = 0;

 Label12.OwnerScreen = &Screen2;
 Label12.Order = 18;
 Label12.Visible = 1;
 Label12.Opacity = 255;
 Label12.Tag = 255;
 Label12.Left = 138;
 Label12.Top = 39;
 Label12.Width = 9;
 Label12.Height = 17;
 Label12.Caption = Label12_Caption;
 Label12.FontName = Tahoma_13x16_Regular;
 Label12.Font_Color = 0x0000;
 Label12.FontHandle = 1;
 Label12.Source = -1UL;
 Label12.Active = 1;
 Label12.OnUp = 0;
 Label12.OnDown = 0;
 Label12.OnClick = 0;
 Label12.OnPress = 0;

 Label13.OwnerScreen = &Screen2;
 Label13.Order = 19;
 Label13.Visible = 1;
 Label13.Opacity = 255;
 Label13.Tag = 255;
 Label13.Left = 138;
 Label13.Top = 62;
 Label13.Width = 8;
 Label13.Height = 17;
 Label13.Caption = Label13_Caption;
 Label13.FontName = Tahoma_13x16_Regular;
 Label13.Font_Color = 0x0000;
 Label13.FontHandle = 1;
 Label13.Source = -1UL;
 Label13.Active = 1;
 Label13.OnUp = 0;
 Label13.OnDown = 0;
 Label13.OnClick = 0;
 Label13.OnPress = 0;

 Label14.OwnerScreen = &Screen2;
 Label14.Order = 20;
 Label14.Visible = 1;
 Label14.Opacity = 255;
 Label14.Tag = 255;
 Label14.Left = 24;
 Label14.Top = 19;
 Label14.Width = 148;
 Label14.Height = 17;
 Label14.Caption = Label14_Caption;
 Label14.FontName = Tahoma_13x16_Regular;
 Label14.Font_Color = 0x0000;
 Label14.FontHandle = 1;
 Label14.Source = -1UL;
 Label14.Active = 1;
 Label14.OnUp = 0;
 Label14.OnDown = 0;
 Label14.OnClick = 0;
 Label14.OnPress = 0;

}

void Init_MCU() {

 SPI3_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, 64, _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_IDLE_2_ACTIVE);
}

void InitVTFTStack() {
 Init_MCU();

 SPI_Set_Active(SPI3_Read, SPI3_Write);

 FT800_Init();


 FT800_Core_ClockSource(_FT800_CLK_SOURCE_EXTERNAL);
 FT800_Core_ClockPLL(_FT800_CLK_PLL_48MHz);


 FT800_Display_SetConfig(&VTFT_FT800_CONFIG_DISPLAY);

 FT800_PWM_SetConfig(&VTFT_FT800_CONFIG_PWM);

 FT800_GPIO_SetConfig(&VTFT_FT800_CONFIG_GPIO);

 FT800_Audio_SetConfig(&VTFT_FT800_CONFIG_AUDIO);

 FT800_Sound_SetConfig(&VTFT_FT800_CONFIG_SOUND);

 FT800_Interrupt_SetConfig(&VTFT_FT800_CONFIG_INTERRUPT);

 FT800_Touch_SetConfig(&VTFT_FT800_CONFIG_TOUCH);

 FT800_TouchTransform_SetConfig(&VTFT_FT800_CONFIG_TOUCHTRANSFORM);


 InitObjects();


 DrawScreen(&Screen2);
}
