#line 1 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/TFT/TFT eigene Programme/libelle_eve/libelle_eve_Code/mikroC PRO for PIC32/libelle_eve_main.c"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/tft/tft eigene programme/libelle_eve/libelle_eve_code/mikroc pro for pic32/libelle_eve_objects.h"
#line 1 "c:/users/alexander wolf/documents/projekte/programmierung/pic/tft/tft eigene programme/libelle_eve/libelle_eve_code/mikroc pro for pic32/ft800_types.h"
#line 21 "c:/users/alexander wolf/documents/projekte/programmierung/pic/tft/tft eigene programme/libelle_eve/libelle_eve_code/mikroc pro for pic32/ft800_types.h"
typedef unsigned char uint8_ft8;
typedef signed char int8_ft8;
typedef unsigned int uint16_ft8;
typedef int int16_ft8;
typedef unsigned long uint32_ft8;
typedef long int32_ft8;
typedef unsigned long long uint64_ft8;
typedef long long int64_ft8;

typedef enum {cmdREAD, cmdWRITE} TCmd;

typedef enum {opNONE, opREAD, opWRITE} TOpr;

typedef enum {umNONE, umDL=1<<0, umCP=1<<1, umGRAM=1<<2} TUpdateMode;

typedef uint8_ft8 TFT800Alpha;
typedef uint8_ft8 TFT800Handle;

typedef struct
{
 int16_ft8 X;
 int16_ft8 Y;
} TFT800Point;

typedef struct
{
 int16_ft8 Left;
 int16_ft8 Top;
 uint16_ft8 Width;
 uint16_ft8 Height;
} TFT800Rect;

typedef union
{
 struct
 {
 uint8_ft8 B;
 uint8_ft8 G;
 uint8_ft8 R;
 };
 uint32_ft8 RGB;
} TFT800Color;

typedef struct
{
 TFT800Color Color;
 TFT800Alpha Alpha;
 uint8_ft8 Width;
} TFT800Pen;

typedef struct
{
 TFT800Color ColorBg;
 TFT800Color Color;


 TFT800Color ColorTo;
 uint8_ft8 Gradient;
 TFT800Alpha Alpha;
 uint8_ft8 Style;
} TFT800Brush;




typedef struct
{

 uint8_ft8 FontWidth[ 256 ];
 uint32_ft8 FontBitmapFormat;
 uint32_ft8 FontLineStride;
 uint32_ft8 FontWidthInPixels;
 uint32_ft8 FontHeightInPixels;
 uint32_ft8 PointerToFontGraphicsData;
} TFT800FontGraphics;

typedef struct
{
 TFT800FontGraphics GrData;
 uint16_ft8 FirstChar;
 uint16_ft8 LastChar;
} TFT800CharSetDsc;

typedef struct
{
 uint32_ft8 Name;
 uint32_ft8 Source;
 TFT800Color Color;
 TFT800Alpha Alpha;
 TFT800Handle Handle;
 TFT800CharSetDsc CharSetDsc;
} TFT800Font;

typedef struct
{
 uint8_ft8 Format;
 uint16_ft8 LineStride;
 uint16_ft8 Height;
} TFT800BmpLayout;

typedef struct
{
 uint8_ft8 FwFlags;
 uint16_ft8 Width;
 uint16_ft8 Height;
} TFT800BmpSize;

typedef struct
{
 uint32_ft8 Source;
 TFT800BmpLayout Layout;
 TFT800BmpSize Size;
} TFT800BmpConfig;

typedef struct
{
 TFT800BmpConfig Configs[16];
 uint8_ft8 Current;
} TFT800BmpHandle;

typedef struct
{
 TFT800BmpConfig Config;
 TFT800Color BlendColor;
 TFT800Alpha Alpha;
 TFT800Handle Handle;
} TFT800Bitmap;

typedef struct
{
 uint16_ft8 Hour;
 uint16_ft8 Min;
 uint16_ft8 Sec;
 uint16_ft8 mSec;
} TFT800Time;

typedef struct
{
 uint32_ft8 DrawingOptions;
 uint16_ft8 Val;
 uint16_ft8 Size;
 uint16_ft8 Range;
 uint16_ft8 Minor;
 uint16_ft8 Major;
 TFT800Time Time;
 uint8_ft8 Style;
} TFT800CoProcGraphics;

typedef struct
{
 TFT800Pen Pen;
 TFT800Brush Brush;
 TFT800Font Font;
 TFT800Bitmap Bitmap;

 TFT800Rect ClipRect;
 TFT800Point Cursor;

 uint8_ft8 Stencil;
 uint8_ft8 Tag;

 TFT800CoProcGraphics CPGraphics;
} TFT800Canvas;

typedef struct
{
 TOpr Opr;
 uint32_ft8 RWPtr;
} TFT800IO;


typedef struct
{

 uint32_ft8 Frequency;
 uint32_ft8 OutRenderMode;
 uint32_ft8 RenderReadScanLine;
 uint32_ft8 RenderWriteTrigger;

 uint32_ft8 hCycle;
 uint32_ft8 hOffset;
 uint32_ft8 hSize;
 uint32_ft8 hSync0;
 uint32_ft8 hSync1;

 uint32_ft8 vCycle;
 uint32_ft8 vOffset;
 uint32_ft8 vSize;
 uint32_ft8 vSync0;
 uint32_ft8 vSync1;

 uint32_ft8 Rotate180;
 uint32_ft8 OutBits;
 uint32_ft8 OutDither;
 uint32_ft8 OutSwizzle;
 uint32_ft8 OutCSpread;
 uint32_ft8 PClockPolarity;
 uint32_ft8 PClock;
} TFT800Display;

typedef struct
{
 uint32_ft8 TouchMode;
 uint32_ft8 TouchADCMode;
 uint32_ft8 TouchCharge;
 uint32_ft8 TouchSettle;
 uint32_ft8 TouchOversample;
 uint32_ft8 TouchRZThreshold;
} TFT800Touch;

typedef struct
{
 uint32_ft8 TransformA;
 uint32_ft8 TransformB;
 uint32_ft8 TransformC;
 uint32_ft8 TransformD;
 uint32_ft8 TransformE;
 uint32_ft8 TransformF;
} TFT800TouchTransform;

typedef struct
{
 uint8_ft8 Enable;
 uint8_ft8 Mask;
 uint8_ft8 Flags;
} TFT800Interrupt;

typedef struct
{
 uint8_ft8 Effect;
 uint8_ft8 Pitch;
 uint8_ft8 Volume;
 uint8_ft8 Play;
} TFT800Sound;

typedef struct
{
 uint32_ft8 StartAddress;
 uint32_ft8 Length;
 uint16_ft8 Frequency;
 uint8_ft8 Format;
 uint8_ft8 Loop;
 uint8_ft8 Volume;
 uint8_ft8 Play;
} TFT800Audio;

typedef struct
{

 uint16_ft8 Freq;
 uint8_ft8 Duty;
} TFT800PWM;

typedef struct
{
 uint8_ft8 GPIODIR;
 uint8_ft8 GPIO;
} TFT800GPIO;

typedef struct
{
 TFT800PWM *pPWMCfg;
 TFT800GPIO *pGPIOCfg;
 TFT800Audio *pAudioCfg;
 TFT800Sound *pSoundCfg;
 TFT800Touch *pTouchCfg;
 TFT800Display *pDisplayCfg;
 TFT800Interrupt *pInterruptCfg;
 TFT800TouchTransform *pTTransformCfg;
} TFT800Config;



typedef struct
{
 struct
 {




 TFT800Color Color;
 TFT800Alpha Alpha;

 uint8_ft8 Tag;

 TFT800Color ClearColor;
 TFT800Alpha ClearAlpha;
 uint8_ft8 ClearStencil;
 uint8_ft8 ClearTag;

 uint16_ft8 LineWidth;
 uint16_ft8 PointSize;

 uint16_ft8 ScissorLeft;
 uint16_ft8 ScissorTop;
 uint16_ft8 ScissorWidth;
 uint16_ft8 ScissorHeight;

 uint8_ft8 BmpHandle;
 uint8_ft8 Cell;

 struct
 {
 Color : 1;
 Alpha : 1;
 Tag : 1;
 ClearColor : 1;
 ClearAlpha : 1;
 ClearStencil : 1;
 ClearTag : 1;
 LineWidth : 1;
 PointSize : 1;
 ScissorPos : 1;
 ScissorSize : 1;
 BmpHandle : 1;
 Cell : 1;

 Unused : 32-13;

 } UpdateFlags;


 } Context;

 TFT800BmpConfig BmpHandleCfg[16];

 int8_ft8 CurrGrPrim;
} TFT800Graphics;

typedef struct
{
 TFT800IO IO;

 TFT800Sound Sound;

 TFT800Audio Audio;

 TFT800Graphics Graphics;

 struct
 { uint16_ft8 Width;
 uint16_ft8 Height;
 } Display;

 uint8_ft8 UpdateMode;

} TFT800Controller;
#line 6 "c:/users/alexander wolf/documents/projekte/programmierung/pic/tft/tft eigene programme/libelle_eve/libelle_eve_code/mikroc pro for pic32/libelle_eve_objects.h"
typedef enum {taNone, taLeft, taCenter, taRight, taCenterX, taCenterY, taRightX} TTextAlign;

typedef struct Screen TScreen;

typedef unsigned long TPointer;

typedef struct tagObjInfo {
 void *Obj;
 char Type;
 char Order;
 char Flags;

 char HitTag;
 int HitX;
 int HitY;
} TObjInfo;

typedef struct tagTouchStat {
 char Pressed;

 char Tag;
 int X;
 int Y;

 TObjInfo ActObjInfo;
} TTouchStat;

typedef void (*TDrawHandler)(TPointer aObj);

typedef void (*TEvtAction)();

typedef struct tagEvtSound {
 char SndAct;
 char Effect;
 char Pitch;
 char Volume;
} TEvtSound;

typedef const struct tagCEvent {
 TEvtAction Action;
 TEvtSound Sound;
} TCEvent;

typedef struct tagEvent {
 TEvtAction Action;
 TEvtSound Sound;
} TEvent;

typedef const struct tagCRect {
 int Left;
 int Top;
 int Width;
 int Height;
} TCRect;

typedef struct tagRect {
 int Left;
 int Top;
 int Width;
 int Height;
} TRect;

typedef struct tagLabel {
 TScreen *OwnerScreen;
 char Order;
 char Visible;
 char Opacity;
 char Tag;
 int Left;
 int Top;
 int Width;
 int Height;
 char *Caption;
 const code char *FontName;
 unsigned int Font_Color;
 char FontHandle;
 long Source;
 char Active;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnClick;
 TEvent *OnPress;
} TLabel;

typedef struct tagCircle {
 TScreen *OwnerScreen;
 char Order;
 char Visible;
 char Opacity;
 char Tag;
 int Left;
 int Top;
 int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 unsigned int Color;
 unsigned int Press_Color;
 char Active;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnClick;
 TEvent *OnPress;
} TCircle;

typedef struct tagEveSlider {
 TScreen *OwnerScreen;
 char Order;
 char Visible;
 char Opacity;
 char Tag;
 int Left;
 int Top;
 int Width;
 int Height;
 unsigned int Background_Color;
 unsigned int Thumb_Color;
 unsigned int Color;
 unsigned int Press_Color;
 unsigned int Value;
 unsigned int Range;
 char Flat;
 char Active;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnClick;
 TEvent *OnPress;
} TEveSlider;

typedef struct tagEveText {
 TScreen *OwnerScreen;
 char Order;
 char Visible;
 char Opacity;
 char Tag;
 int Left;
 int Top;
 int Width;
 int Height;
 char *Caption;
 TTextAlign TextAlign;
 const code char *FontName;
 unsigned int Font_Color;
 char FontHandle;
 long Source;
 char Active;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnClick;
 TEvent *OnPress;
} TEveText;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned short LabelsCount;
 TLabel *const code *Labels;
 unsigned short CirclesCount;
 TCircle *const code *Circles;
 unsigned short EveSlidersCount;
 TEveSlider *const code *EveSliders;
 unsigned short EveTextsCount;
 TEveText *const code *EveTexts;
 unsigned long DynResStart;
 unsigned short Active;
 unsigned short SniffObjectEvents;
 TEvent *OnUp;
 TEvent *OnDown;
 TEvent *OnTagChange;
 TEvent *OnPress;
};




extern const VTFT_OT_LABEL;
extern const VTFT_OT_CIRCLE;
extern const VTFT_OT_EVESLIDER;
extern const VTFT_OT_EVETEXT;




extern const VTFT_EVT_UP;
extern const VTFT_EVT_DOWN;
extern const VTFT_EVT_CLICK;
extern const VTFT_EVT_PRESS;




extern const VTFT_SNDACT_NONE;
extern const VTFT_SNDACT_PLAY;
extern const VTFT_SNDACT_STOP;




extern const VTFT_LOAD_RES_NONE;
extern const VTFT_LOAD_RES_STATIC;
extern const VTFT_LOAD_RES_DYNAMIC;
extern const VTFT_LOAD_RES_ALL;




extern const VTFT_DISPLAY_EFF_NONE;
extern const VTFT_DISPLAY_EFF_LIGHTS_FADE;
extern const VTFT_DISPLAY_EFF_LIGHTS_OFF;




extern const VTFT_INT_REPAINT_ON_DOWN;
extern const VTFT_INT_REPAINT_ON_UP;
extern const VTFT_INT_BRING_TO_FRONT;
extern const VTFT_INT_INTRINSIC_CLICK_EFF;




extern const TPointer DrawHandlerTable[44];



extern const TFT800PWM VTFT_FT800_CONFIG_PWM;
extern const TFT800GPIO VTFT_FT800_CONFIG_GPIO;
extern const TFT800Sound VTFT_FT800_CONFIG_SOUND;
extern const TFT800Audio VTFT_FT800_CONFIG_AUDIO;
extern const TFT800Display VTFT_FT800_CONFIG_DISPLAY;
extern const TFT800Interrupt VTFT_FT800_CONFIG_INTERRUPT;
extern const TFT800Touch VTFT_FT800_CONFIG_TOUCH;
extern const TFT800TouchTransform VTFT_FT800_CONFIG_TOUCHTRANSFORM;

extern TTouchStat TouchS;

extern TScreen Screen2;

extern TEveSlider EveSlider_Basisachse;
extern TEvent EveSlider_Basisachse_OnPress;
extern TEveSlider EveSlider_Achse2;
extern TEvent EveSlider_Achse2_OnPress;
extern TCircle Circle2;
extern TCircle Circle4;
extern TCircle Circle_Blase;
extern TEveText EveText2;
extern TEveText EveText3;
extern TLabel Label10;
extern TLabel Label3;
extern TLabel Label4;
extern TLabel Label1;
extern TLabel Label5;
extern TLabel Label6;
extern TLabel Label2;
extern TLabel Label7;
extern TLabel Label8;
extern TLabel Label9;
extern TLabel Label11;
extern TLabel Label12;
extern TLabel Label13;
extern TLabel Label14;

extern TLabel *const code Screen2_Labels[14];
extern TCircle *const code Screen2_Circles[3];
extern TEveSlider *const code Screen2_EveSliders[2];
extern TEveText *const code Screen2_EveTexts[2];

extern TScreen *CurrentScreen;



void EveSlider_Achse2OnPress();
void EveSlider_BasisachseOnPress();




extern char EveSlider_Basisachse_Caption[];
extern char EveSlider_Achse2_Caption[];
extern char Circle2_Caption[];
extern char Circle4_Caption[];
extern char Circle_Blase_Caption[];
extern char EveText2_Caption[];
extern char EveText3_Caption[];
extern char Label10_Caption[];
extern char Label3_Caption[];
extern char Label4_Caption[];
extern char Label1_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label2_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char Label9_Caption[];
extern char Label11_Caption[];
extern char Label12_Caption[];
extern char Label13_Caption[];
extern char Label14_Caption[];



extern TEvent EveSlider_Basisachse_OnUpOnPress;
extern TEvent EveSlider_Achse2_OnUpOnPress;


void DrawScreenO(TScreen *aScreen, char aOptions);
void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawCircle(TCircle *ACircle);
void DrawEveSlider(TEveSlider *AEveSlider);
void DrawEveText(TEveText *AEveText);
void ProcessVTFTStack();
void InitVTFTStack();
#line 29 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/TFT/TFT eigene Programme/libelle_eve/libelle_eve_Code/mikroC PRO for PIC32/libelle_eve_main.c"
char txt_tmp[9];
TFT800TouchTransform CalibrateConstants;

void refresh_coordinates()
{
 FT800_TouchTransform_GetConfig(&CalibrateConstants);

 LongWordToHex(CalibrateConstants.TransformA, txt_tmp);

 strcpy(Label1_Caption,txt_tmp);

 LongWordToHex(CalibrateConstants.TransformB, txt_tmp);

 strcpy(Label2_Caption,txt_tmp);

 LongWordToHex(CalibrateConstants.TransformC, txt_tmp);

 strcpy(Label3_Caption,txt_tmp);

 LongWordToHex(CalibrateConstants.TransformD, txt_tmp);

 strcpy(Label4_Caption,txt_tmp);

 LongWordToHex(CalibrateConstants.TransformE, txt_tmp);

 strcpy(Label5_Caption,txt_tmp);

 LongWordToHex(CalibrateConstants.TransformF, txt_tmp);

 strcpy(Label6_Caption,txt_tmp);


 DrawScreen(&Screen2);
}

void Set__coordinates(){

 CalibrateConstants.TransformA = 0x00007E93;
 CalibrateConstants.TransformB = 0x00000039;
 CalibrateConstants.TransformC = 0xFFF21215;
 CalibrateConstants.TransformD = 0x000001A0;
 CalibrateConstants.TransformE = 0x00004A6B;
 CalibrateConstants.TransformF = 0xFFF1376E;

 FT800_TouchTransform_SetConfig(&CalibrateConstants);

}








void main() {
 volatile int a=0;
 InitVTFTStack();
#line 93 "C:/Users/Alexander Wolf/Documents/PROJEKTE/PROGRAMMIERUNG/PIC/TFT/TFT eigene Programme/libelle_eve/libelle_eve_Code/mikroC PRO for PIC32/libelle_eve_main.c"
 while (1) {
 ProcessVTFTStack();
 refresh_coordinates();
 if ( a == 0){
 Set__coordinates();
 refresh_coordinates();
 a=1;
 }
 }
}
